#! /bin/env python
# A simple HTML Picture Gallery creator.
# Original script by j_garrett@altavista.com
# Attribute captions, about text import,
# set names, and backgrounds by Scot Hacker (beos@birdhouse.org)

import sys, os, string, shutil

# Import Chris Herbort's python attribute handler
import BeOS.fsattr

def nameonly(temp):
	index=0; temp=""
	while index < string.find(image,'.jpg') :
		temp = temp + image[index]
		index = index+1
	return temp		

def filesize(name):
	size = (os.path.getsize(targetdir+"/"+image)/1024)
	return string.replace(str(size),'L','K')

if len(sys.argv) == 4:
	print "\nUsage: \t sgallery.py dirname columns setname background\n"
	print "Where columns is the number of thumbnails per row (default is 5).\n"
	print "Where setname is a title for the collection -- in quotes if multi-word.\n"
	print "Where background is the name of a backgrond image tile in the backgrounds folder.\n"	
	print "Thumber must be in your path and all filenames should be JPEG's and"
	print "have the extension .jpg (must be lowercase).\n"
	print "A text file called \"about\" must  exist in the image dir."	
	print "It will become the intro paragraph  for the collection.\n"	
	sys.exit()
else:
	targetdir = string.replace(sys.argv[1], '/' , '')
	set_name = sys.argv[3]	
	background = sys.argv[4]		


# We only want the jpegs from the list, otherwise the cleanup routine barfs
	filelist = os.listdir(targetdir)
	filenames = [ ]
	for file in filelist:
		if string.count(file,".jpg"):
			filenames.append(file)
                             
	indexp = targetdir+".html"
	about_text = targetdir+"/about"
	try:
		cols = int(sys.argv[2])
	except IndexError:
		cols = 5
	count=1
	thumbdir = (targetdir+"/thumbs")
	
	
# Cleaning up old files
if os.path.exists(targetdir+"/thumbs"):
	print "\nRemoving old files\n"
	shutil.rmtree(targetdir+"/thumbs")
	for filename in filelist:
		if string.count(filename,".html"):
			os.remove(targetdir+"/"+filename)



#Generate Index Page
print "Writing index page\n\n",
file=open(indexp,'w')
file.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\"> \n")
file.write("<HTML> \n<HEAD> \n<TITLE>"+set_name+"</TITLE>\n</HEAD> \n<BODY TEXT=\"#000000\" background=\"backgrounds/"+background+"\">\n<font face=\"Arial\">\n")
file.write("<DIV align=\"CENTER\">\n<TABLE border=\"0\" cellspacing=\"2\">\n<TD><font face=\"Arial\">\n<blockquote><blockquote>\n<H1>"+set_name+"</H1>\n")

# Read in the about text
file.write ( open(about_text, "r").read() )

file.write("</blockquote></blockquote>\n</TD>\n</TABLE>\n")
file.write("<TABLE BORDER=\"0\" CELLSPACING=\"2\" CELLPADDING=\"1\">\n<TR>\n")


# Loop through images in dir
for image in filenames:

	# Extract attribs and get short caption for each image in dir
	attrs = BeOS.fsattr.read_attrs( targetdir+"/"+image )
	shortcap = attrs.get( "IMG:short_cap", ( 0, "No caption" ) )[1]

	if count > cols :
		count = 1
		file.write("</TR>\n<TR>\n")
	print str(count)+" ",
	page=nameonly(image)+".html"						 
	file.write("\t<TD><TABLE><TR><TD><A HREF=\""+targetdir+"/"+page+"\"><IMG SRC=\""+thumbdir+"/"+image+"\" HEIGHT=\"100\" WIDTH=\"100\" BORDER=\"0\"></A></TD>\n")
	file.write("<TR><TD><font face=\"Arial\"><b>"+shortcap+"</b><br>("+filesize(image)+")</TD></TR></TABLE></TD>\n")
	count = count+1
	
file.write("</TR>\n</TABLE>\n<P><I>Click thumbnails for full size images.</I></P>\n</DIV>\n")
file.write("<blockquote><blockquote><a href=\"index.html\">Return to photo gallery</a></blockquote></blockquote></BODY>\n</HTML>")

#Generate Picture Pages
print "\n\nWriting picture pages\n\n",
for image in filenames:
	page=targetdir+"/"+nameonly(image)+".html"
	
	# Extract attribs and get long caption for each image in dir
	attrs = BeOS.fsattr.read_attrs( targetdir+"/"+image )
	longcap = attrs.get( "IMG:long_cap", ( 0, "I have no caption" ) )[1]
	
	file=open(page,'w')
	file.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\"> \n")
	file.write("<HTML> \n<HEAD> \n<TITLE>"+nameonly(image)+"</TITLE>\n</HEAD> \n<BODY TEXT=\"#000000\" background=\"../backgrounds/"+background+"\">\n<font face=\"Arial\">\n")
	file.write("<DIV align=\"CENTER\">\n<h3>"+set_name+"</h3>\n<TABLE border=\"0\" cellspacing=\"2\">\n<TR>\n<TD align=\"left\"><font face=\"Arial\"><b>"+longcap+"</b>\n</TD>\n</TR>\n<TR>\n")
	file.write("<TD align=\"center\"><IMG SRC=\""+image+"\" BORDER=\"0\"></TD>\n</TR>\n")
	file.write("<TR>\n<TD><A HREF=\"../"+indexp+"\"><font size=\"+1\"><font face=\"Arial\"><b>Image index</b></font></A></TD>\n</TR>\n</TABLE>\n</DIV>\n")
	file.write("</BODY>\n</HTML>")
	file.close()
	print "Creating page for image " + image


#Create thumbnails	!! thumber must be installed in your path	
print "\nThumber making thumbnails\n"
os.mkdir(targetdir+"/thumbs")
cmd = "thumber -i " + targetdir +  " -o " + thumbdir + "/ -w 100 -h 100"
os.system(cmd)

		
		


	
